/*
 *
 * Xilinx, Inc.
 * XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS" AS A 
 * COURTESY TO YOU.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION AS
 * ONE POSSIBLE   IMPLEMENTATION OF THIS FEATURE, APPLICATION OR 
 * STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS IMPLEMENTATION 
 * IS FREE FROM ANY CLAIMS OF INFRINGEMENT, AND YOU ARE RESPONSIBLE 
 * FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE FOR YOUR IMPLEMENTATION
 * XILINX EXPRESSLY DISCLAIMS ANY WARRANTY WHATSOEVER WITH RESPECT TO 
 * THE ADEQUACY OF THE IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO 
 * ANY WARRANTIES OR REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE 
 * FROM CLAIMS OF INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY 
 * AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/*
 * 
 *
 * This file is a generated sample test application.
 *
 * This application is intended to test and/or illustrate some 
 * functionality of your system.  The contents of this file may
 * vary depending on the IP in your system and may use existing
 * IP driver functions.  These drivers will be generated in your
 * SDK application project when you run the "Generate Libraries" menu item.
 *
 */


#include <stdio.h>
#include "string.h"
#include "xparameters.h"
#include "xenv_standalone.h"
#include "xintc.h"
#include "intc_header.h"
#include "xbasic_types.h"
#include "xgpio.h"
#include "xuartns550_l.h"
#include "uartlite_header.h"
#include "usb_epp.h"
#include "sleep.h"
#include "lcd.h"
#include "xlltemac.h"
#include "xlltemac_example.h"
#include "lltemac_header.h"
#include "lltemac_intr_header.h"
#include "xlldma.h"
#include "ac97_if_00.h"


#define USB_EPP_SWITCH_REG 0x10
#define USB_EPP_BUTTON_REG 0x11
#define USB_EPP_COMMAND_REG 0x80
#define USB_EPP_STATUS_REG 0x81
#define USB_EPP_RESULT_REG 0x82
#define USB_EPP_ERROR_REG_0 0x83
#define USB_EPP_ERROR_REG_1 0x84
#define USB_EPP_ERROR_REG_2 0x85
#define USB_EPP_ERROR_REG_3 0x86

#define FLASH_ADDRESS_REG_0 0x87
#define FLASH_ADDRESS_REG_1 0x88
#define FLASH_ADDRESS_REG_2 0x89

#define DATA_SIZE_REG_0 0x90
#define DATA_SIZE_REG_1 0x91
#define DATA_SIZE_REG_2 0x92
#define DATA_SIZE_REG_3 0x93

#define DATA_RECEIVE_REG 0xA0

#define STATUS_TEST_RUNNING 0xFF
#define STATUS_BIST_STARTED_IDLE 0x01
#define STATUS_COMMAND_RECEIVED 0x02
#define STATUS_UNRECOGNIZED_COMMAND 0x0F
#define STATUS_DATA_RECEIVE_MODE 0x03
#define STATUS_DATA_SEND_MODE 0x04
#define STATUS_BIST_NOT_STARTED_IDLE 0x00

#define STATUS_TEST_FAILED 0x01
#define STATUS_TEST_PASSED 0x00

//global variables for test
Xuint32 Current_Command	=	0x00;
Xuint32 Current_UART_Command = 0x00;
Xuint32 Current_Status 	= 	0x00;
Xuint32 Current_Result 	= 	0x00;
Xuint32 Bist_Started_EPP = 0x00;

Xuint32 Error_Code;


//represents the number of bytes received
Xuint32 Count_bytes =0;

unsigned char verbose = 0; //used to toggle verbose mode

//flash address bytes
unsigned char flash_addr_0;
unsigned char flash_addr_1;
unsigned char flash_addr_2;
//represents the current address
Xuint32 Flash_Starting_Addr;

//data size bytes
unsigned char data_size_0;
unsigned char data_size_1;
unsigned char data_size_2;
unsigned char data_size_3;
//represents the data size
Xuint32 Data_Size;


//to store the current byte;
unsigned char current_byte;
//to store the current halfword in the DDRAM
Xuint16 FLASH_DATA;

char uart_msg[2]; //will store the received characters

unsigned short dip, dip_pre; //used to determine the status of the DIP switches
unsigned short push, push_pre; //used to determine the status of the pushbuttons
					//1 - Center
					
unsigned char gpio_devices[16]; //shows the status of the GPIO devices,
//0 - unchanged, 1 - pressed or on, 2 - released or off
//0 to 7 - DIP switches, 8-12 - push buttons, 13 - reset button

//GPIO devices
XGpio DIP8, Push7, LED8;
XGpio Pmod_Conn, VHDCI_1_Conn, VHDCI_2_Conn, PS2_Conn;

//interrupt controller
XIntc Intc;

XLlTemac Hard_Ethernet_MAC_LlTemac;
XLlDma Hard_Ethernet_MAC_LlDma;
XLlTemac_Config *MacCfgPtr;



void usb_epp_interrupt_handler(void * baseaddr_p) {

Xuint32 Usb_epp_data;
Xuint32 Usb_epp_address;
Xuint32 Usb_epp_status;


	Usb_epp_status = XIo_In32(XPAR_USB_EPP_IF_0_BASEADDR + USB_EPP_STATUS_REG_OFFSET);
	//xil_printf("\r\nUSB_EPP_Status = 0x%0.8X", 	Usb_epp_status);
	
	if (Usb_epp_status & USB_EPP_STATUS_READ_REQUESTED){
		
		Usb_epp_address = XIo_In32 (XPAR_USB_EPP_IF_0_BASEADDR + USB_EPP_ADDRESS_REG_OFFSET); 
		
		if ((Current_Status == STATUS_DATA_SEND_MODE) 
			&& (Usb_epp_address == DATA_RECEIVE_REG))
		{
			Usb_epp_data  =	XIo_In8 (XPAR_FLASH_MEM0_BASEADDR + Flash_Starting_Addr + Count_bytes);
			Count_bytes++;
		}
		else
		{
			switch (Usb_epp_address)
			{
			case USB_EPP_COMMAND_REG: Usb_epp_data = Current_Command;
			break;
			case USB_EPP_STATUS_REG: Usb_epp_data = Current_Status;
			break;
			case USB_EPP_RESULT_REG: Usb_epp_data = Current_Result;
			break;
			case USB_EPP_SWITCH_REG: Usb_epp_data = XIo_In32 (XPAR_DIP_SWITCHES_8BIT_BASEADDR);
			break;
			case USB_EPP_BUTTON_REG: Usb_epp_data = XIo_In32 (XPAR_PUSH_BUTTONS_7BIT_BASEADDR);
			break;
			case USB_EPP_ERROR_REG_0: Usb_epp_data = Error_Code & 0x000000FF;
			break;
			case USB_EPP_ERROR_REG_1: Usb_epp_data = (Error_Code >> 8) & 0x000000FF;
			break;
			case USB_EPP_ERROR_REG_2: Usb_epp_data = (Error_Code >> 16) & 0x000000FF;
			break;
			case USB_EPP_ERROR_REG_3: Usb_epp_data = (Error_Code >> 24) & 0x000000FF;
			break;
			case FLASH_ADDRESS_REG_0: Usb_epp_data = flash_addr_0;
			break;
			case FLASH_ADDRESS_REG_1: Usb_epp_data = flash_addr_1;
			break;
			case FLASH_ADDRESS_REG_2: Usb_epp_data = flash_addr_2;
			break;
			case DATA_SIZE_REG_0: Usb_epp_data = data_size_0;
			break;
			case DATA_SIZE_REG_1: Usb_epp_data = data_size_1;
			break;
			case DATA_SIZE_REG_2: Usb_epp_data = data_size_2;
			break;
			case DATA_SIZE_REG_3: Usb_epp_data = data_size_3;
			break;
			case DATA_RECEIVE_REG: Usb_epp_data = current_byte;
			break;
			}
		}

		//acknowledge the interrupt by setting the address from the status to the address register, then writing into the specified address
		XIo_Out32(XPAR_USB_EPP_IF_0_BASEADDR + USB_EPP_DATA_REG_OFFSET, Usb_epp_data);
	}
	
	else if (Usb_epp_status & USB_EPP_STATUS_WRITE_PERFORMED)
	{
		
		Usb_epp_address = XIo_In32 (XPAR_USB_EPP_IF_0_BASEADDR + USB_EPP_ADDRESS_REG_OFFSET); 
		//acknowledge the interrupt by reading from the current address
		Usb_epp_data = XIo_In32(XPAR_USB_EPP_IF_0_BASEADDR + USB_EPP_DATA_REG_OFFSET);
		
		//XIo_Out32(XPAR_LEDS_8BIT_BASEADDR, Count_bytes);

		if ((Current_Status == STATUS_DATA_RECEIVE_MODE) 
			&& (Usb_epp_address == DATA_RECEIVE_REG))
		//write the data in the memory
		{
			current_byte = Usb_epp_data & 0x000000FF;
			XIo_Out8(XPAR_DDR2_SDRAM_MPMC_BASEADDR + Count_bytes, current_byte);
			Count_bytes++;
			//Current_Status = STATUS_BIST_STARTED_IDLE;
		}
		else if (((Current_Status == STATUS_BIST_STARTED_IDLE) 
			     || (Current_Status == STATUS_UNRECOGNIZED_COMMAND))
				 && (Usb_epp_address == USB_EPP_COMMAND_REG))
		{
			Current_Command = Usb_epp_data;
			Current_Status = STATUS_COMMAND_RECEIVED;

			//write status into the status register
		}
		else if ((Current_Status == STATUS_BIST_NOT_STARTED_IDLE) && (Usb_epp_address == USB_EPP_COMMAND_REG)
			&& (Usb_epp_data == 0x01))
		{
			Current_Command = Usb_epp_data;
			Current_Status = STATUS_BIST_STARTED_IDLE;
			Bist_Started_EPP = 1;
		}
		else
		{
			switch (Usb_epp_address)
			{
				case FLASH_ADDRESS_REG_0: flash_addr_0 = Usb_epp_data;
				break;
				case FLASH_ADDRESS_REG_1: flash_addr_1 = Usb_epp_data;
				break;
				case FLASH_ADDRESS_REG_2: flash_addr_2 = Usb_epp_data;
				break;
				case DATA_SIZE_REG_0: data_size_0 = Usb_epp_data;
				break;
				case DATA_SIZE_REG_1: data_size_1 = Usb_epp_data;
				break;
				case DATA_SIZE_REG_2: data_size_2 = Usb_epp_data;
				break;
				case DATA_SIZE_REG_3: data_size_3 = Usb_epp_data;
				break;
//				case DATA_RECEIVE_REG: current_byte = Usb_epp_data;
//				break;
			}	
		}
		
	}

	Usb_epp_status = XIo_In32(XPAR_USB_EPP_IF_0_BASEADDR + USB_EPP_STATUS_REG_OFFSET);
	}	

void uart_scan()
{
unsigned char_num=0;
 
 uart_msg[0]=uart_msg[1];
 uart_msg[1] = XUartNs550_RecvByte(XPAR_UARTNS550_0_BASEADDR);
  // beep (1,100,100);
   
//   xil_printf(uart_msg);
   //XUartNs550_SendByte(XPAR_UARTNS550_0_BASEADDR, uart_msg[0]);
   //XUartNs550_SendByte(XPAR_UARTNS550_0_BASEADDR, uart_msg[1]);
}

unsigned int Command_check()
{
//check if a valid command was received
unsigned int command_num;
//returns the number of the test to run
//0  - no new command received
//0x06  - Ethernet test, command received is "eh"
//0x07 -  USB host and device test, command received is "us"
//0x08 - PS2 open test, command received is "po"
//0x09 - PS2 short test, commans received is "ps"
//0x0b - enable verbose mode, command received is "vb"
//0x016 - Ethernet Auto negotiate, command received is "en"
//0x18 - Pmod Connector open test, command received is "mo"
//0x19 - Pmod Connector short test, commans received is "ms"
//0x1a - UART 2 loopback test, command received is "u2"
//0x28 - VHDCI open test, command received is "vo"
//0x29 - VHDCI short test, command received is "vs"


   command_num=0;
   if      (!(strcmp(uart_msg, "li"))) command_num = 0x04;
   else if (!(strcmp(uart_msg, "mh"))) command_num = 0x05;
   else if (!(strcmp(uart_msg, "eh"))) command_num = 0x06;
   else if (!(strcmp(uart_msg, "us"))) command_num = 0x07;
   else if (!(strcmp(uart_msg, "po"))) command_num = 0x08;
   else if (!(strcmp(uart_msg, "ps"))) command_num = 0x09;
   else if (!(strcmp(uart_msg, "vb"))) command_num = 0x0b;
   else if (!(strcmp(uart_msg, "en"))) command_num = 0x16;
   else if (!(strcmp(uart_msg, "mo"))) command_num = 0x18;
   else if (!(strcmp(uart_msg, "ms"))) command_num = 0x19;
   else if (!(strcmp(uart_msg, "u2"))) command_num = 0x1a;
   else if (!(strcmp(uart_msg, "vo"))) command_num = 0x28;
   else if (!(strcmp(uart_msg, "vs"))) command_num = 0x29;
         
   return command_num;
}

unsigned int Command_Received()
{
unsigned int command_num=0;

   if (XUartNs550_mIsReceiveData(XPAR_RS232_UART_0_BASEADDR))
   {
      uart_msg[0]=uart_msg[1];
      uart_msg[1]=XUartNs550_mReadReg(XPAR_RS232_UART_0_BASEADDR, XUN_RBR_OFFSET);
      command_num=Command_check();
   }
   return command_num;
}

void MessageTrap(char * LCD_Msg1, char * LCD_Msg2, char* UART_Msg, unsigned int Pass)
{
   
 LCDClear();
 LCDPrintString (LCD_Msg1,LCD_Msg2);
 
 xil_printf(UART_Msg);

}


//insert before main()
extern int _start;
extern int _exception_handler;
extern int __interrupt_handler;

int main() 
{

	Xuint32 i, j;

	Xuint32 sw_data, btn_data;

	XStatus Status;
	
	Xuint32 err=0;
	
	Xuint32 temp;
	
	Xuint8 Led_data = 0;

Xuint32 Failed_Address = 0;

Xuint32 FLASH_SIZE = XPAR_FLASH_MEM0_HIGHADDR - XPAR_FLASH_MEM0_BASEADDR + 1;
	
Xuint32 Usb_epp_data;
Xuint32 Usb_epp_address;
Xuint32 Usb_epp_status;


//insert after main() and after variable declarations
//insert after main() and after variable declarations
  int x=&_start;
  *(int*)(0x0)=0xb0000000 | (((x) & 0xFFFF0000) >> 16);
  *(int*)(0x4)=0xb8080000 | (((x) & 0xFFFF));
  x=&_exception_handler;
  *(int*)(0x8)=0xb0000000 | (((x) & 0xFFFF0000) >> 16);
  *(int*)(0xC)=0xb8080000 | (((x) & 0xFFFF));
  x=&__interrupt_handler;
  *(int*)(0x10)=0xb0000000 | (((x) & 0xFFFF0000) >> 16);
  *(int*)(0x14)=0xb8080000 | (((x) & 0xFFFF));  

   /* Initialize RS232_Uart_0 - Set baudrate and number of stop bits */
   XUartNs550_SetBaud(XPAR_RS232_UART_0_BASEADDR, XPAR_XUARTNS550_CLOCK_HZ, 9600);
   XUartNs550_mSetLineControlReg(XPAR_RS232_UART_0_BASEADDR, XUN_LCR_8_DATA_BITS);


   XCACHE_ENABLE_ICACHE();
   XCACHE_ENABLE_DCACHE();


   //print("---Entering main---\n\r");
   
  LCDOff();
  LCDClear();
  LCDOn();
  LCDInit();
  //LCDPrintString   ("- GENESYS USER -",
  //				  "- DEMO / BIST  -");

  Status = XIntc_Initialize (&Intc, XPAR_XPS_INTC_0_DEVICE_ID);
 
   if (Status != XST_SUCCESS) xil_printf ("\r\nInterrupt controller initialization failure");
   else xil_printf("\r\nInterrupt controller initialized");
   
   Status = XIntc_Connect (&Intc, XPAR_XPS_INTC_0_USB_EPP_IF_0_EPP_IRPT_INTR,
                             (XInterruptHandler) usb_epp_interrupt_handler,
                             (void *)XPAR_USB_EPP_IF_0_BASEADDR);
  if (Status != XST_SUCCESS) xil_printf ("\r\nRegistering USB_EPP Interupt Failed");
  else xil_printf("\r\nUSB_EPP Interrupt registerred");

  XIntc_Enable  (&Intc, XPAR_XPS_INTC_0_USB_EPP_IF_0_EPP_IRPT_INTR); 
   
   
  Status = XIntc_Start(&Intc, XIN_REAL_MODE);
  if (Status != XST_SUCCESS) xil_printf ("\r\nInterupt controller starting failed");
  else xil_printf("\r\nInterrupt controller started");
  
  microblaze_enable_interrupts();
  
   MacCfgPtr = XLlTemac_LookupConfig(XPAR_HARD_ETHERNET_MAC_CHAN_0_DEVICE_ID);
   Status = XLlTemac_CfgInitialize(&Hard_Ethernet_MAC_LlTemac, MacCfgPtr,
                   MacCfgPtr->BaseAddress);
   if (Status != XST_SUCCESS) {
       TemacUtilErrorTrap("Error in initialize");
       return XST_FAILURE;
   }
  
   Gpio_devices_initialize();  
  
   Ac97_Codec_Initialize();
  

	 LCDClear();
     LCDPrintString ("Loading Bitmap..",
  				     "");

  Status =  Decode_display_bitmap();

  
   xil_printf("\r\n----------------------------------------------------------\r\n");
   xil_printf("\r\nGenesys Board Test Image \r\n");
   xil_printf("\r\n----------------------------------------------------------\r\n");
   
     LCDClear();
     LCDPrintString ("- GENESYS USER -",
  				     "-  DEMO / BIST -");
	
	Count_bytes =0;
	//wait until test starts
	while (Current_Status != STATUS_BIST_STARTED_IDLE)			 
	{
	
	  	poll_gpio_devices (DIP8, Push7, LED8);
	
	if (XUartNs550_mIsReceiveData(XPAR_RS232_UART_0_BASEADDR))
		if (XUartNs550_mReadReg(XPAR_RS232_UART_0_BASEADDR, XUN_RBR_OFFSET) == 'x')
		{
			Current_Status = STATUS_BIST_STARTED_IDLE;
			Bist_Started_EPP = 0;
		}
	}
	

	
	MessageTrap("    GENESYS     ","--BIST Started--", "x1.p\n", 1);
/**********************************************************************************
 * MAIN TEST LOOP
 * *******************************************************************************/
   while (1)
   {
   	
  	poll_gpio_devices (DIP8, Push7, LED8);

   	if (Current_Status == STATUS_COMMAND_RECEIVED) 
   	{
		switch (Current_Command)
		{
		 case 0x01: //Start BIST command when BIST is already started, ignore it
			Current_Status = STATUS_BIST_STARTED_IDLE;
			Current_Command = 0x01;
		 break;
		case 0x02: //DDR2 test is not running in this configuration
			Current_Status = STATUS_UNRECOGNIZED_COMMAND;
		 break;
		case 0x03: //Flash test is not runnign in this configuration
			Current_Status = STATUS_UNRECOGNIZED_COMMAND;
		 break;	
		case 0x04: //Audio Line-In to Line-Out Test
			Current_Status = STATUS_TEST_RUNNING;
			MessageTrap("-Audio  Line-In-","--TEST Running--", "li.r\n", 0);
		    Failed_Address = Audio_Test (AC97_LINE_IN_SELECT, XPAR_DDR2_SDRAM_MPMC_BASEADDR + 0x4000000, 0x17700);
			Current_Result = STATUS_TEST_PASSED;
		    Current_Status = STATUS_BIST_STARTED_IDLE;
		    MessageTrap("-Audio  Line-In-","-TEST Finished--", "li.p\n", 1);
		 break;
		case 0x05: //Audio Mic In to Headphone Out Test
			Current_Status = STATUS_TEST_RUNNING;
			MessageTrap("--Audio Mic In--","--TEST Running--", "mh.r\n", 0);
		    Failed_Address = Audio_Test (AC97_MIC_SELECT, XPAR_DDR2_SDRAM_MPMC_BASEADDR + 0x4000000, 0x17700);
			Current_Result = STATUS_TEST_PASSED;
		    Current_Status = STATUS_BIST_STARTED_IDLE;
		    MessageTrap("--Audio Mic In--","-TEST Finished--", "mh.p\n", 1);
		 break;
		case 0x06: //Ethernet Test
			Current_Status = STATUS_TEST_RUNNING;
		    Failed_Address = Eth_Test();
		    if (Failed_Address)
		    {
		    	Current_Result = STATUS_TEST_FAILED;
				Error_Code = Failed_Address;
				MessageTrap("    Ethernet    ","--TEST  Failed--", "eh.f\n", 0);	
		    }
		    else
		    {
		    	Current_Result = STATUS_TEST_PASSED;
				Error_Code = 0;
				MessageTrap("    Ethernet    ","--TEST   Passed--", "eh.p\n", 1);	
		    }
		    Current_Status = STATUS_BIST_STARTED_IDLE;		
		 break;
		case 0x07: //USB Host and device test
			Current_Status = STATUS_TEST_RUNNING;
		    Failed_Address = USB_Test(XPAR_RS232_UART_0_BASEADDR);
		    if (Failed_Address)
		    {
		    	Current_Result = STATUS_TEST_FAILED;
				Error_Code = Failed_Address;
				MessageTrap("USB  Host/Device","--TEST  Failed--", "us.f\n", 0);	
		    }
		    else
		    {
		    	Current_Result = STATUS_TEST_PASSED;
				Error_Code = 0;
				MessageTrap("USB  Host/Device","--TEST   Passed--", "us.p\n", 1);	
		    }
		    Current_Status = STATUS_BIST_STARTED_IDLE;		
		 break;
		case 0x08: //PS2 open test
			Current_Status = STATUS_TEST_RUNNING;
		    Failed_Address = PS2_loopback_test(PS2_Conn);
		    if (Failed_Address)
		    {
		    	Current_Result = STATUS_TEST_FAILED;
				Error_Code = Failed_Address;
				MessageTrap("- PS2 Loopback -","--TEST  Failed--", "po.f\n", 0);	
		    }
		    else
		    {
		    	Current_Result = STATUS_TEST_PASSED;
				Error_Code = 0;
				MessageTrap("- PS2 Loopback -","--TEST   Passed--", "po.p\n", 1);	
		    }
		    Current_Status = STATUS_BIST_STARTED_IDLE;		
		 break;
		case 0x09: //PS2 short test
			Current_Status = STATUS_TEST_RUNNING;
		    Failed_Address = PS2_short_test(PS2_Conn);
		    if (Failed_Address)
		    {
		    	Current_Result = STATUS_TEST_FAILED;
				Error_Code = Failed_Address;
				MessageTrap("--  PS2 Short --","--TEST  Failed--", "ps.f\n", 0);	
		    }
		    else
		    {
		    	Current_Result = STATUS_TEST_PASSED;
				Error_Code = 0;
				MessageTrap("--  PS2 Short --","--TEST   Passed--", "ps.p\n", 1);	
		    }
		    Current_Status = STATUS_BIST_STARTED_IDLE;		
		 break;
		case 0x0a: //UART 1 Test
			Current_Status = STATUS_TEST_RUNNING;
		    Failed_Address = UART_Test(XPAR_RS232_UART_0_BASEADDR);
		    if (Failed_Address)
		    {
		    	Current_Result = STATUS_TEST_FAILED;
				Error_Code = Failed_Address;
				MessageTrap("--   UART 1   --","--TEST  Failed--", "u1.f\n", 0);	
		    }
		    else
		    {
		    	Current_Result = STATUS_TEST_PASSED;
				Error_Code = 0;
				MessageTrap("--   UART 1   --","--TEST   Passed--", "u1.p\n", 1);	
		    }
		    Current_Status = STATUS_BIST_STARTED_IDLE;		
		 break;
		case 0x0b: //Toggle verbose mode
			Current_Status = STATUS_TEST_RUNNING;
			verbose = !verbose;
			if (verbose)
			{
				Error_Code = 0x01;
				MessageTrap("--   Verbose  --","--     ON    --", "vb.m\n", 1);	
			}
			else
			{
				Error_Code = 0x00;
				MessageTrap("--   Verbose  --","--     OFF   --", "vb.f\n", 0);	
			}
			Current_Result = STATUS_TEST_PASSED;
			Current_Status = STATUS_BIST_STARTED_IDLE;
		 break;
		case 0x0c: //Enter receive data mode
			Current_Status = STATUS_TEST_RUNNING;
		    Current_Status = STATUS_BIST_STARTED_IDLE;		
		 break;
		case 0x0d: //Enter send data mode
			Current_Status = STATUS_TEST_RUNNING;
		    Current_Status = STATUS_BIST_STARTED_IDLE;		
		 break;		
	    case 0x16: //Enter send data mode
			Current_Status = STATUS_TEST_RUNNING;
			Failed_Address = Eth_Autonegotiation_Test();
		    if (Failed_Address)
		    {
		    	Current_Result = STATUS_TEST_FAILED;
				Error_Code = Failed_Address;
				MessageTrap(" Ethernet  Auto ","Negotiate  Failed", "en.f\n", 0);	
		    }
		    else
		    {
		    	Current_Result = STATUS_TEST_PASSED;
				Error_Code = 0;
				MessageTrap(" Ethernet  Auto ","Negotiate Passed", "en.p\n", 1);
		    }
		    Current_Status = STATUS_BIST_STARTED_IDLE;		
		 break;
		case 0x18: //Pmod Connector open test
			Current_Status = STATUS_TEST_RUNNING;
		    Failed_Address = Pmod_Conn_loopback_test(Pmod_Conn);
		    if (Failed_Address)
		    {
		    	Current_Result = STATUS_TEST_FAILED;
				Error_Code = Failed_Address;
				MessageTrap(" Pmod Loopback  ","--TEST  Failed--", "mo.f\n", 0);	
		    }
		    else
		    {
		    	Current_Result = STATUS_TEST_PASSED;
				Error_Code = 0;
				MessageTrap(" Pmod Loopback  ","--TEST   Passed--", "mo.p\n", 1);	
		    }
		    Current_Status = STATUS_BIST_STARTED_IDLE;		
		 break;
		case 0x19: //Pmod Connector short test
			Current_Status = STATUS_TEST_RUNNING;
		    Failed_Address = Pmod_Conn_short_test(Pmod_Conn);
		    if (Failed_Address)
		    {
		    	Current_Result = STATUS_TEST_FAILED;
				Error_Code = Failed_Address;
				MessageTrap("-- Pmod Short --","--TEST  Failed--", "ms.f\n", 0);	
		    }
		    else
		    {
		    	Current_Result = STATUS_TEST_PASSED;
				Error_Code = 0;
				MessageTrap("-- Pmod Short --","--TEST   Passed--", "ms.p\n", 1);	
		    }
		    Current_Status = STATUS_BIST_STARTED_IDLE;		
		 break;
		case 0x1a: //UART 2 Test
			Current_Status = STATUS_TEST_RUNNING;
		    Failed_Address = UART_Test(XPAR_RS232_UART_1_BASEADDR);
		    if (Failed_Address)
		    {
		    	Current_Result = STATUS_TEST_FAILED;
				Error_Code = Failed_Address;
				MessageTrap("--   UART 2   --","--TEST  Failed--", "u2.f\n", 0);	
		    }
		    else
		    {
		    	Current_Result = STATUS_TEST_PASSED;
				Error_Code = 0;
				MessageTrap("--   UART 2   --","--TEST   Passed--", "u2.p\n", 1);	
		    }
		    Current_Status = STATUS_BIST_STARTED_IDLE;		
		 break;
		case 0x28: //VHDCI Connector open test
			Current_Status = STATUS_TEST_RUNNING;
		    Failed_Address = Vhdci_Conn_loopback_test(VHDCI_1_Conn, VHDCI_2_Conn);
		    if (Failed_Address)
		    {
		    	Current_Result = STATUS_TEST_FAILED;
				Error_Code = Failed_Address;
				MessageTrap("-Vhdci Loopback-","--TEST  Failed--", "vo.f\n", 0);	
		    }
		    else
		    {
		    	Current_Result = STATUS_TEST_PASSED;
				Error_Code = 0;
				MessageTrap("-Vhdci Loopback-","--TEST   Passed--", "vo.p\n", 1);	
		    }
		    Current_Status = STATUS_BIST_STARTED_IDLE;		
		 break;		
		case 0x29: //Vhdci Connector short test
			Current_Status = STATUS_TEST_RUNNING;
		    Failed_Address = Vhdci_Conn_short_test(VHDCI_1_Conn, VHDCI_2_Conn);
		    if (Failed_Address)
		    {
		    	Current_Result = STATUS_TEST_FAILED;
				Error_Code = Failed_Address;
				MessageTrap("-- Vhdci Short --","--TEST  Failed--", "vs.f\n", 0);	
		    }
		    else
		    {
		    	Current_Result = STATUS_TEST_PASSED;
				Error_Code = 0;
				MessageTrap("-- Vhdci Short --","--TEST   Passed--", "vs.p\n", 1);	
		    }
		    Current_Status = STATUS_BIST_STARTED_IDLE;		
		 break;

		default:
			Current_Status = STATUS_UNRECOGNIZED_COMMAND;
		break;
		}
    }
		//check if command was received from the UART
		if ((Current_Status == STATUS_BIST_STARTED_IDLE)
		    && (!(Bist_Started_EPP)))
   		{
   		  Current_UART_Command = Command_Received();
   		  if (Current_UART_Command)
   		  {
   		  	Current_Command = Current_UART_Command;
			Current_Status = STATUS_COMMAND_RECEIVED;
   		  }
   		}	
   }
 

   return 0;
}

