/******************************************************************************
*
*       XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
*       AS A COURTESY TO YOU, SOLELY FOR USE IN DEVELOPING PROGRAMS AND
*       SOLUTIONS FOR XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE,
*       OR INFORMATION AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE,
*       APPLICATION OR STANDARD, XILINX IS MAKING NO REPRESENTATION
*       THAT THIS IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
*       AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
*       FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
*       WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
*       IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
*       REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
*       INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
*       FOR A PARTICULAR PURPOSE.
*
*       (c) Copyright 2007 Xilinx Inc.
*       All rights reserved.
*
******************************************************************************/

#include "xparameters.h"
#include "stdio.h"
#include "xintc.h"
#include "intc_header.h"
#include "xuartns550_l.h"
#include "xutil.h"
#include "xio.h"
#include "sleep.h"
#include "xbasic_types.h"
#include "xlldma.h"
#include "xuartns550_l.h"
#include "uartns550_header.h"

extern unsigned char verbose;


int UART_Test(Xuint32 UART_BASEADDR)
{

   XStatus Status;
   Xuint32 i;
   char data=0;
   
   XUartNs550_SetBaud(UART_BASEADDR, XPAR_XUARTNS550_CLOCK_HZ, 9600);
   XUartNs550_mSetLineControlReg(UART_BASEADDR, XUN_LCR_8_DATA_BITS);

   //clear UART FIFO before starting the test
   while (XUartNs550_mIsReceiveData(UART_BASEADDR))
   data=XUartNs550_mReadReg(UART_BASEADDR, XUN_RBR_OFFSET);
   
   XUartNs550_SendByte(UART_BASEADDR, 0x55);

   i=0;
   while (!(XUartNs550_mIsReceiveData(UART_BASEADDR)))
   {
	   i++;
      usleep(10);
      if (i==500)
      {
          //if (verbose) xil_printf ("\r\nUART communication timeout");
             return XTEST_FAILED;
             break;
      }
   }
   
   data=XUartNs550_mReadReg(UART_BASEADDR, XUN_RBR_OFFSET);
   
   if (data==0x55) return XTEST_PASSED;
   else return XTEST_FAILED;
}
